﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim cursor1 As Cursor
	Private smiley As Bitmap
	
	'Dim SelectedRow As Int					: SelectedRow = -1
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private wbvTable As WebView
	Private lblSelectedItem As Label
	Private HtmlCSS As String
	'Dim wbvTable2 As ScrollView

	
	HtmlCSS = "table {width: 100%;border: 1px solid #cef;text-align: left; }" _
		& " th { font-weight: bold;	background-color: #acf;	border-bottom: 1px solid #cef; }" _ 
		& "td,th {	padding: 4px 5px; }" _
		& ".odd {background-color: #def; } .odd td {border-bottom: 1px solid #cef; }" _
		& "a { text-decoration:none; color: #000;}"
End Sub

Sub ShowTable

	Private Query As String
	Query = "SELECT DISTINCT Datesent,Sms as SentMessage,ID FROM Sentmessages"
	'depending if the filter is active or not we add the filter query at the end of the query
	'the filter query is defined in the Filter Activity
	If Starter.flagFilterActive = False Then
		'btnFilter.Initialize("Filter")
		'btnFilter.Text = "Filter"	'change the text in the Filter button
	Else
		Query = Query & Starter.FilterQuery
		'btnFilter.Text = "UnFilter"	'change the text in the Filter button
	End If
	'displays the database in a table
	wbvTable.LoadHtml(ExecuteHtml(Starter.SQL1, Query, Null, 0, True))
	ReadDataBaseIDs
End Sub
Sub ReadDataBaseIDs
	Private Row As Int
	Private cursor1 As Cursor
	
	Starter.IDList.Initialize		'initialize the ID list

	'We read only the ID column and put them in a List
	If Starter.flagFilterActive = False Then
		cursor1 = Starter.SQL1.ExecQuery("SELECT ID FROM Sentmessages")
	Else
		cursor1 = Starter.SQL1.ExecQuery("SELECT ID FROM Sentmessages" & Starter.FilterQuery)
	End If
	
	If cursor1.RowCount > 0 Then						'check if entries exist
		Starter.RowNumber = cursor1.RowCount					'set the row count variable
		Starter.IDList.Initialize											'initialize the ID list
		For Row = 0 To  Starter.RowNumber - 1
			cursor1.Position = Row							'set the Cursor to each row
			Starter.IDList.Add(cursor1.GetInt("ID"))		'add the ID's to the ID list
		Next
		Starter.CurrentIndex = 0											'set the current index to 0
	Else
		Starter.CurrentIndex = -1											'set the current index to -1, no selected item
		ToastMessageShow("No items found", False)
	End If
	cursor1.Close														'close the cursor, we don't need it anymore
End Sub

Sub wbvTable_OverrideUrl (Url As String) As Boolean
	'parse the row and column numbers from the URL
	
	'Dim kk As String = Row
	'Log(kk)
	'List_Delete(Row)
	If lblSelectedItem.Text="Recieved" Then
		Private values() As String
		values = Regex.Split("[.]", Url.SubString(7))
		Private  Row As Int
	
		Row = values(1)		'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@  Was 0
		Starter.CurrentIndex = Row
	UpdateSelectedItem200
	Else
		If lblSelectedItem.Text="Send" Then
			Private values() As String
			values = Regex.Split("[.]", Url.SubString(7))
			Private  Row As Int
	
			Row = values(1)		'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@  Was 0
			Starter.CurrentIndex = Row
 	UpdateSelectedItem2
	 End If
	 End If
	Return True 'Don't try to navigate to this URL
End Sub


Sub UpdateSelectedItem200
Private Answ As Int
	
Answ = Msgbox2("Do you really want to delete the selected entry ?", "D E L E T E", "Yes", "", "No", Null)
	
	If Answ = DialogResponse.POSITIVE Then
		Private Query As String
		Private Curs As Cursor
		Query = "SELECT DISTINCT Sms, Daterecieved FROM Recievedsms WHERE ID = " & Starter.IDList.Get(Starter.CurrentIndex)
		Curs = Starter.SQL1.ExecQuery(Query)
		Curs.Position = 0
		Dim strSQL As String
		Dim strName As String
		Dim strNames As String
		Try
			strName =Curs.GetString("Sms")
			strNames =Curs.GetString("Daterecieved")
			
			strSQL = "DELETE FROM Recievedsms WHERE sms = ? AND Daterecieved = ?"
				
			Starter.SQL1.ExecNonQuery2(strSQL, Array As Object(strName, strNames))
			Curs.Close
			ToastMessageShow("Message Deleted successfully", False)
		Catch
			Log(LastException)
		End Try
	ShowTable2
		
End If
		
End Sub
Sub ExecuteHtml(SQL As SQL, Query As String, StringArgs() As String, Limit As Int, Clickable As Boolean) As String
	Private cur As Cursor
	If StringArgs <> Null Then
		cur = SQL.ExecQuery2(Query, StringArgs)
	Else
		cur = SQL.ExecQuery(Query)
	End If
	Log("ExecuteHtml: " & Query)
	If Limit > 0 Then Limit = Min(Limit, cur.RowCount) Else Limit = cur.RowCount
	Private sb As StringBuilder
	sb.Initialize
	sb.Append("<html><body>").Append(CRLF)
	sb.Append("<style type='text/css'>").Append(HtmlCSS).Append("</style>").Append(CRLF)
	sb.Append("<table><tr>").Append(CRLF)
	For i = 0 To cur.ColumnCount - 1
		sb.Append("<th>").Append(cur.GetColumnName(i)).Append("</th>")
	Next
	
	sb.Append("</tr>").Append(CRLF)
	For row = 0 To Limit - 1
		cur.Position = row
		If row Mod 2 = 0 Then
			sb.Append("<tr>")
		Else
			sb.Append("<tr class='odd'>")
		End If
		For i = 0 To cur.ColumnCount - 1
			sb.Append("<td>")
			If Clickable Then
				sb.Append("<a href='http://").Append(i).Append(".")
				sb.Append(row)
'				sb.Append(".com'>").Append(cur.GetString2(i)).Append("</a>")
				sb.Append(".stub'>").Append(cur.GetString2(i)).Append("</a>")
		
			Else
				sb.Append(cur.GetString2(i))
			End If
			sb.Append("</td>")
		Next
		sb.Append("</tr>").Append(CRLF)
		
	Next
	cur.Close
	sb.Append("</table></body></html>")
	Return sb.ToString
End Sub


Sub ShowTable2

	Private Query As String
	Query = "SELECT DISTINCT Daterecieved,Sms as RecievedMessage,ID FROM Recievedsms"
	'depending if the filter is active or not we add the filter query at the end of the query
	'the filter query is defined in the Filter Activity
	If Starter.flagFilterActive = False Then
		'btnFilter.Initialize("Filter")
		'btnFilter.Text = "Filter"	'change the text in the Filter button
	Else
		Query = Query & Starter.FilterQuery
		'btnFilter.Text = "UnFilter"	'change the text in the Filter button
	End If
	'displays the database in a table
	wbvTable.LoadHtml(ExecuteHtml2(Starter.SQL1, Query, Null, 0, True))
	ReadDataBaseIDs2
End Sub
Sub ReadDataBaseIDs2
	Private Row As Int
	Private cursor1 As Cursor
	
	Starter.IDList.Initialize		'initialize the ID list

	'We read only the ID column and put them in a List
	If Starter.flagFilterActive = False Then
		cursor1 = Starter.SQL1.ExecQuery("SELECT ID FROM Recievedsms")
	Else
		cursor1 = Starter.SQL1.ExecQuery("SELECT ID FROM Recievedsms" & Starter.FilterQuery)
	End If
	
	If cursor1.RowCount > 0 Then						'check if entries exist
		Starter.RowNumber = cursor1.RowCount					'set the row count variable
		Starter.IDList.Initialize											'initialize the ID list
		For Row = 0 To  Starter.RowNumber - 1
			cursor1.Position = Row							'set the Cursor to each row
			Starter.IDList.Add(cursor1.GetInt("ID"))		'add the ID's to the ID list
		Next
		Starter.CurrentIndex = 0											'set the current index to 0
	Else
		Starter.CurrentIndex = -1											'set the current index to -1, no selected item
		ToastMessageShow("No items found", False)
	End If
	cursor1.Close														'close the cursor, we don't need it anymore
End Sub

Sub wbvTable_OverrideUrl2 (Url As String) As Boolean
	'parse the row and column numbers from the URL
	'parse the row and column numbers from the URL
	Private values() As String
	values = Regex.Split("[.]", Url.SubString(7))
	Private  Row As Int
	
	Row = values(1)		'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@  Was 0
	Starter.CurrentIndex = Row
	'Dim kk As String = Row
	'Log(kk)
	'List_Delete(Row)
	UpdateSelectedItem2

Return True 'Don't try to navigate to this URL
End Sub

Sub UpdateSelectedItem2
	Private Answ As Int
	
	Answ = Msgbox2("Do you really want to delete the selected entry ?", "D E L E T E", "Yes", "", "No", Null)
	
	If Answ = DialogResponse.POSITIVE Then

		'Starter.SQL1.ExecNonQuery("DELETE FROM Sentmessages WHERE ID =" & Starter.IDList.Get(Starter.Currentindex))
		
		Private Query As String
		Private Curs As Cursor
		Query = "SELECT DISTINCT Sms, Datesent FROM Sentmessages WHERE ID = " & Starter.IDList.Get(Starter.CurrentIndex)
		Curs = Starter.SQL1.ExecQuery(Query)
		Curs.Position = 0
		Dim strSQL As String
		Dim strName As String
		Dim strNames As String
		Try
			strName =Curs.GetString("Sms")
			strNames =Curs.GetString("Datesent")
			
			strSQL = "DELETE FROM Sentmessages WHERE sms = ? AND Datesent = ?"
				
			Starter.SQL1.ExecNonQuery2(strSQL, Array As Object(strName, strNames))
			ToastMessageShow("Message Deleted successfully", False)
			Curs.Close
		Catch
			Log(LastException)
		End Try
		ShowTable
		
	End If
	
End Sub
Sub ExecuteHtml2(SQL As SQL, Query As String, StringArgs() As String, Limit As Int, Clickable As Boolean) As String
	Private cur As Cursor
	If StringArgs <> Null Then
		cur = SQL.ExecQuery2(Query, StringArgs)
	Else
		cur = SQL.ExecQuery(Query)
	End If
	Log("ExecuteHtml: " & Query)
	If Limit > 0 Then Limit = Min(Limit, cur.RowCount) Else Limit = cur.RowCount
	Private sb As StringBuilder
	sb.Initialize
	sb.Append("<html><body>").Append(CRLF)
	sb.Append("<style type='text/css'>").Append(HtmlCSS).Append("</style>").Append(CRLF)
	sb.Append("<table><tr>").Append(CRLF)
	For i = 0 To cur.ColumnCount - 1
		sb.Append("<th>").Append(cur.GetColumnName(i)).Append("</th>")
	Next
	
	sb.Append("</tr>").Append(CRLF)
	For row = 0 To Limit - 1
		cur.Position = row
		If row Mod 2 = 0 Then
			sb.Append("<tr>")
		Else
			sb.Append("<tr class='odd'>")
		End If
		For i = 0 To cur.ColumnCount - 1
			sb.Append("<td>")
			If Clickable Then
				sb.Append("<a href='http://").Append(i).Append(".")
				sb.Append(row)
'				sb.Append(".com'>").Append(cur.GetString2(i)).Append("</a>")
				sb.Append(".stub'>").Append(cur.GetString2(i)).Append("</a>")
		
			Else
				sb.Append(cur.GetString2(i))
			End If
			sb.Append("</td>")
		Next
		sb.Append("</tr>").Append(CRLF)
		
	Next
	cur.Close
	sb.Append("</table></body></html>")
	Return sb.ToString
End Sub

Sub Activity_Create(FirstTime As Boolean)
	If FirstTime Then
		smiley = LoadBitmapResize(File.DirAssets, "smiley.png", 24dip, 24dip, False)
	End If
	'Do not forget to load the layout file created with the visual designer. For example:
	If  IsConnectedToInternet=True Then
	replysms
		'HighPriority_Notification
	Activity.LoadLayout("simplechat")
	Activity.Title="Chat"
	Dim SQLQry As String = "DELETE FROM SMSlist"
	Starter.SQL1.ExecNonQuery(SQLQry)
	cursor1 = Starter.SQL1.ExecQuery("SELECT phone AS Phone,Sex FROM Register")
	If cursor1.RowCount > 0 Then
			cursor1.Position =0
		Dim phone As String
		phone = cursor1.Getstring("Phone")
			Dim sx As String
		sx = cursor1.Getstring("Sex")
		'Next
	End If
	Dim CustID As String = phone' Customer ID
	Dim jt As HttpJob
	jt.Initialize("", Me)
	jt.Download("http://kccug.com/Generic_Handler_JSON/HandlerVBRegistration.ashx?customerid=" & CustID & "&sx=" & sx)
	jt.GetRequest.Timeout = 10000 ' 10 seconds
	Wait For (jt) JobDone(jt As HttpJob)
	If jt.Success Then ' if job is success (http status code 200)
		Dim RetVal As String
		RetVal = jt.GetString
		If jt.GetString = "[]" Then
			'Msgbox("Please try Again ","SMIS")
			'Return
			
		Else
			
			Dim jpt As JSONParser
			jpt.Initialize(jt.GetString)
			'Log(jpt) ' will pr
				Log($"Token(${jpt})"$)
			Dim quotes As List = jpt.NextArray
			For Each quot As Map In quotes
				'	Log("Account: " & quot.Get("Account"))
				Log("Name: " & quot.Get("Name"))
				Log("Category: " & quot.Get("Category"))
				Log("Froms: " & quot.Get("Froms"))
				Log("Tos: " & quot.Get("Tos"))
				Log(DateTime.Date(JsonDateToTick( quot.Get("Froms"))))
				Dim l As Long
				DateTime.DateFormat = "dd/MM/yyyy" ' "1961-08-29"
				Dim datestring As String = DateTime.Date(JsonDateToTick( quot.Get("Froms")))
				l = DateTime.DateParse(datestring)
				DateTime.DateFormat = "dd/MM/yyyy"
				Log(DateTime.Date(l))
				
				Log(DateTime.Date(JsonDateToTick( quot.Get("Tos"))))
				Dim lt As Long
				DateTime.DateFormat = "dd/MM/yyyy" ' "1961-08-29"
				Dim datestring As String = DateTime.Date(JsonDateToTick( quot.Get("Tos")))
				lt = DateTime.DateParse(datestring)
				DateTime.DateFormat = "dd/MM/yyyy"
				Log(DateTime.Date(lt))
				'End If
				'Grab the last ID number which is the highest number
				If quot.Get("Category")="Inactive" Then
					MsgboxAsync("Your Account is Inactive Please Pay 60000/= Via Mobile Money On 0782911364 Or 0702822227 to Activate" ,"SMIS")
					Return
				End If
				If quot.Get("Category")="Expired" Then
					MsgboxAsync("Your Registration has Already Expired it was Valid from: " & DateTime.Date(l) &" To:"& DateTime.Date(lt) &" Please Pay 60000/= Via Mobile Money On 0782911364 Or 0702822227 to Activate" ,"SMIS")
					Return
						
				Else

					'Starter.SQL1.ExecNonQuery("INSERT INTO SMSlist VALUES('" & quot.Get("Account") & "','" & quot.Get("Name") & "','" & CustID & "','" & sx & "','" & 1 & "')")
						Starter.SQL1.ExecNonQuery2("INSERT INTO SMSlist VALUES(?, ?, ?,?,?)", Array As Object(quot.Get("Account"), quot.Get("Name"),CustID ,sx, 1))
	
		
					'Log(quot.Get("Account"))
					'Log(quot.Get("Name"))
					'Log(quot.Get(phone))
					'Log(quot.Get(sx))
					Log(RetVal) ' will print in log value returned from the server
					
	
				End If
			Next
		
		End If
	
	End If
	'InitSpinners
		'Msgbox("Records Processed Successfully. You Can Now Check ","SMIS")
	Else
MsgboxAsync("Error Connecting to the Server Please Check Your Internet Connection","Server Error")
		Activity.LoadLayout("simplechat")
		Activity.Title="Chat"
		Return
		End If
End Sub
Sub IsConnectedToInternet As Boolean
	Dim r As Reflector
 
	r.Target = r.GetContext
	r.Target = r.RunMethod2("getSystemService", "connectivity", "java.lang.String")
	r.Target = r.RunMethod("getActiveNetworkInfo")
 
	If r.Target <> Null Then
		Return r.RunMethod("isConnectedOrConnecting")
	End If
 
	Return False
End Sub
Sub replysms
	'Dim SQLQry As String = "DELETE FROM Recievedsms"
	'Starter.SQL1.ExecNonQuery(SQLQry)
	cursor1 = Starter.SQL1.ExecQuery("SELECT phone AS Phone,Sex FROM Register")
	If cursor1.RowCount > 0 Then
		cursor1.Position =0
		Dim phone As String
		phone = cursor1.Getstring("Phone")
		Dim sx As String
		sx = cursor1.Getstring("Sex")
	'	sx = "Father"
	End If
	Dim CustID As String = phone' Customer ID
	Dim jtk As HttpJob
	jtk.Initialize("", Me)
	'j.Download("http://192.168.1.239/Generic_Handler_JSON/HandlerVB.ashx?customerid=" & CustID)
	jtk.Download("http://kccug.com/Generic_Handler_JSON/HandlerVBGetreply.ashx?customerid=" & CustID & "&bcode=" & sx)
	'jtk.Download("http://192.168.1.239/Generic_Handler_JSON/HandlerVBGetreply.ashx?customerid=" & CustID & "&bcode=" & sx)
	jtk.GetRequest.Timeout = 10000 ' 10 seconds
	Wait For (jtk) JobDone(jtk As HttpJob)

	If jtk.Success Then ' if job is success (http status code 200)
		Dim RetVal As String
		Log(RetVal)
		RetVal = jtk.GetString
		If jtk.GetString = "[]" Then
			'Msgbox("Please try Again ","SMIS")
			'Return
			
		Else
					
			Dim jpt As JSONParser
			jpt.Initialize(jtk.GetString)
			'Log(jpt) ' will pr
			Log($"Token(${jpt})"$)
			Dim quotes As List = jpt.NextArray
			For Each quot As Map In quotes
			Log("Account: " & quot.Get("Account"))
			Log("sms: " & quot.Get("sms"))
				Log("Datesent: " & quot.Get("Datesent"))
				Log("Status: " & quot.Get("Status"))
				Log("codes: " & quot.Get("Code"))
				Log("atk: " & quot.Get("atk"))
			'Log("Tos: " & quot.Get("Tos"))
				Dim ltt As Long
				DateTime.DateFormat = "dd/MM/yyyy" ' "1961-08-29"
				Dim datestring As String = DateTime.Date(JsonDateToTick( quot.Get("Datesent")))
				ltt = DateTime.DateParse(datestring)
				DateTime.DateFormat = "dd/MM/yyyy"
				Log(DateTime.Date(ltt))
				Dim now As Long
				now = DateTime.Now
				Log(DateTime.Now)
				DateTime.DateFormat = "dd/MM/yyyy" : DateTime.TimeFormat = "hh:mm a"
				
				Log(DateTime.Date(ltt)& " "& DateTime.Time(now))
				Starter.SQL1.ExecNonQuery2("INSERT INTO Recievedsms VALUES(?, ?, ?)", Array As Object(DateTime.Date(ltt)& " "& DateTime.Time(now), quot.Get("sms"), quot.Get("Code")))
	
				Dim n As NB6
				n.Initialize("default", Application.LabelName, "HIGH").SmallIcon(smiley)
				n.Build(quot.Get("sms"), "Kabojja Junior School", "tag", Main).Notify(9)
				
				Dim jtkt As HttpJob
				jtkt.Initialize("", Me)
				jtkt.Download("http://kccug.com/Generic_Handler_JSON/HandlerVBDelReply.ashx?customerid=" &  quot.Get("atk"))
			Next
			
		End If
	
End If
End Sub
Sub JsonDateToTick(s As String) As Long
	Dim m As Matcher = Regex.Matcher("\d+", s)
	If m.Find Then
		Return m.Match
	End If
	Log("Invalid date: " & s)
	Return 0
End Sub
Sub Activity_Resume
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub btnFilter_Click
	If IsConnectedToInternet=True Then
		cursor1 = Starter.SQL1.ExecQuery("SELECT Account FROM SMSlist")
		If cursor1.RowCount > 0 Then
			StartActivity(Sendsms)
			'Activity.Title="Send SMS"
	Else
		Dim SQLQry As String = "DELETE FROM SMSlist"
		Starter.SQL1.ExecNonQuery(SQLQry)
		cursor1 = Starter.SQL1.ExecQuery("SELECT phone AS Phone,Sex FROM Register")
		If cursor1.RowCount > 0 Then
			cursor1.Position =0
			Dim phone As String
			phone = cursor1.Getstring("Phone")
			Dim sx As String
			sx = cursor1.Getstring("Sex")
			'Next
		End If
		Dim CustID As String = phone' Customer ID
		Dim jt As HttpJob
		jt.Initialize("", Me)
		jt.Download("http://kccug.com/Generic_Handler_JSON/HandlerVBRegistration.ashx?customerid=" & CustID & "&sx=" & sx)
		jt.GetRequest.Timeout = 10000 ' 10 seconds
		Wait For (jt) JobDone(jt As HttpJob)
		If jt.Success Then ' if job is success (http status code 200)
			Dim RetVal As String
			RetVal = jt.GetString
			If jt.GetString = "[]" Then
				'Msgbox("Please try Again ","SMIS")
				'Return
			
			Else
			
				Dim jpt As JSONParser
				jpt.Initialize(jt.GetString)
				'Log(jpt) ' will pr
					Log($"Token(${jpt})"$)
				Dim quotes As List = jpt.NextArray
				For Each quot As Map In quotes
					'	Log("Account: " & quot.Get("Account"))
					Log("Name: " & quot.Get("Name"))
					Log("Category: " & quot.Get("Category"))
					Log("Froms: " & quot.Get("Froms"))
					Log("Tos: " & quot.Get("Tos"))
					Log(DateTime.Date(JsonDateToTick( quot.Get("Froms"))))
					Dim l As Long
					DateTime.DateFormat = "dd/MM/yyyy" ' "1961-08-29"
					Dim datestring As String = DateTime.Date(JsonDateToTick( quot.Get("Froms")))
					l = DateTime.DateParse(datestring)
					DateTime.DateFormat = "dd/MM/yyyy"
					Log(DateTime.Date(l))
				
					Log(DateTime.Date(JsonDateToTick( quot.Get("Tos"))))
					Dim lt As Long
					DateTime.DateFormat = "dd/MM/yyyy" ' "1961-08-29"
					Dim datestring As String = DateTime.Date(JsonDateToTick( quot.Get("Tos")))
					lt = DateTime.DateParse(datestring)
					DateTime.DateFormat = "dd/MM/yyyy"
					Log(DateTime.Date(lt))
					'End If
					'Grab the last ID number which is the highest number
					If quot.Get("Category")="Inactive" Then
						MsgboxAsync("Your Account is Inactive Please Pay 60000/= Via Mobile Money On 0782911364 Or 0702822227 to Activate" ,"SMIS")
						Return
					End If
					If quot.Get("Category")="Expired" Then
						MsgboxAsync("Your Registration has Already Expired it was Valid from: " & DateTime.Date(l) &" To:"& DateTime.Date(lt) &" Please Pay 60000/= Via Mobile Money On 0782911364 Or 0702822227 to Activate" ,"SMIS")
						Return
						
					Else

						'Starter.SQL1.ExecNonQuery("INSERT INTO SMSlist VALUES('" & quot.Get("Account") & "','" & quot.Get("Name") & "','" & CustID & "','" & sx & "','" & 1 & "')")
						
							Starter.SQL1.ExecNonQuery2("INSERT INTO SMSlist VALUES(?,?,?,?,?)", Array As Object(quot.Get("Account"), quot.Get("Name"), CustID,sx,1))
	
						'Log(quot.Get("Account"))
						'Log(quot.Get("Name"))
						'Log(quot.Get(phone))
						'Log(quot.Get(sx))
						Log(RetVal) ' will print in log value returned from the server
					
	
					End If
				Next
		
			End If
	
		End If
	End If
		StartActivity(Sendsms)
	Else
MsgboxAsync("Error Connecting to the Server Please Check Your Internet Connection","Server Error")
		Return
	End If
End Sub
Sub HighPriority_Notification
	Dim n As NB6
	n.Initialize("default", Application.LabelName, "HIGH").SmallIcon(smiley)
	n.Build("Important Good Work sula!!!", "Content", "tag", Me).Notify(9)
End Sub
Sub btnEdit_Click
	ShowTable
	lblSelectedItem.Text="Send"
End Sub

Sub btnAdd_Click
	
	ShowTable2
	lblSelectedItem.Text="Recieved"
End Sub