﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim cursor1 As Cursor
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private wbvTable As WebView
	Private WebView1 As WebView
	Private HtmlCSS As String
	HtmlCSS = "table {width: 100%;border: 1px solid #cef;text-align: left; }" _
		& " th { font-weight: bold;	background-color: #acf;	border-bottom: 1px solid #cef; }" _ 
		& "td,th {	padding: 4px 5px; }" _
		& ".odd {background-color: #def; } .odd td {border-bottom: 1px solid #cef; }" _
		& "a { text-decoration:none; color: #000;}"
	Dim Account As EditText
	Dim Classr As EditText
	Dim Latestdata As RadioButton
	Dim kname As String
	Dim spnFirstName As Spinner
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("academicextract")
	Activity.Title="Extract Results"
	WebView1.Visible=False
	
	ShowTable
End Sub

Sub IsConnectedToInternet As Boolean
	Dim r As Reflector
 
	r.Target = r.GetContext
	r.Target = r.RunMethod2("getSystemService", "connectivity", "java.lang.String")
	r.Target = r.RunMethod("getActiveNetworkInfo")
 
	If r.Target <> Null Then
		Return r.RunMethod("isConnectedOrConnecting")
	End If
 
	Return False
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub wbvTable_OverrideUrl (Url As String) As Boolean
	'parse the row and column numbers from the URL
	Private values() As String
	values = Regex.Split("[.]", Url.SubString(7))
	Private row As Int
	row = values(1)
	Starter.CurrentIndex = row
	UpdateSelectedItem
	Dim values() As String
	values = Regex.Split("[.]", Url.SubString(7))
	
	'ToastMessageShow("User pressed on column: " & col & " and row: " & row, False)
	'Return True 'Don't try to navigate to this URL
	Return True 'Don't try to navigate to this URL
End Sub
Sub ShowTable
	'Dim SQLQry As String = "DELETE FROM Balances"
	'Starter.SQL1.ExecNonQuery(SQLQry)
	Private Query As String
	Query = "SELECT DISTINCT Names,Class || Stream As CS,Amount As Balance FROM Balances"
	'depending if the filter is active or not we add the filter query at the end of the query
	'the filter query is defined in the Filter Activity
	If Starter.flagFilterActive = False Then
		'btnFilter.Initialize("Filter")
		'se
		'Query = Query & Starter.FilterQuery
		'btnFilter.Text = "UnFilter"	'change the text in the Filter button
	End If
	'displays the database in a table
	wbvTable.LoadHtml(ExecuteHtml(Starter.SQL1, Query, Null, 0, True))
	ReadDataBaseIDs
End Sub

Sub ReadDataBaseIDs
	Private Row As Int
	Private cursor1 As Cursor
	
	Starter.IDList.Initialize		'initialize the ID list

	'We read only the ID column and put them in a List
	If Starter.flagFilterActive = False Then
		cursor1 = Starter.SQL1.ExecQuery("SELECT ID FROM Balances")
	Else
		cursor1 = Starter.SQL1.ExecQuery("SELECT ID FROM Balances" & Starter.FilterQuery)
	End If
	
	If cursor1.RowCount > 0 Then						'check if entries exist
		Starter.RowNumber = cursor1.RowCount					'set the row count variable
		Starter.IDList.Initialize											'initialize the ID list
		For Row = 0 To  Starter.RowNumber - 1
			cursor1.Position = Row							'set the Cursor to each row
			Starter.IDList.Add(cursor1.GetInt("ID"))		'add the ID's to the ID list
		Next
		Starter.CurrentIndex = 0											'set the current index to 0
	Else
		Starter.CurrentIndex = -1											'set the current index to -1, no selected item
		ToastMessageShow("No items found", False)
	End If
	cursor1.Close														'close the cursor, we don't need it anymore
End Sub

Sub ExecuteHtml(SQL As SQL, Query As String, StringArgs() As String, Limit As Int, Clickable As Boolean) As String
	Private cur As Cursor
	If StringArgs <> Null Then
		cur = SQL.ExecQuery2(Query, StringArgs)
	Else
		cur = SQL.ExecQuery(Query)
	End If
	Log("ExecuteHtml: " & Query)
	If Limit > 0 Then Limit = Min(Limit, cur.RowCount) Else Limit = cur.RowCount
	Private sb As StringBuilder
	sb.Initialize
	sb.Append("<html><body>").Append(CRLF)
	sb.Append("<style type='text/css'>").Append(HtmlCSS).Append("</style>").Append(CRLF)
	sb.Append("<table><tr>").Append(CRLF)
	For i = 0 To cur.ColumnCount - 1
		sb.Append("<th>").Append(cur.GetColumnName(i)).Append("</th>")
	Next
	
	sb.Append("</tr>").Append(CRLF)
	For row = 0 To Limit - 1
		cur.Position = row
		If row Mod 2 = 0 Then
			sb.Append("<tr>")
		Else
			sb.Append("<tr class='odd'>")
		End If
		For i = 0 To cur.ColumnCount - 1
			sb.Append("<td>")
			If Clickable Then
				sb.Append("<a href='http://").Append(i).Append(".")
				sb.Append(row)
'				sb.Append(".com'>").Append(cur.GetString2(i)).Append("</a>")
				sb.Append(".stub'>").Append(cur.GetString2(i)).Append("</a>")
		
			Else
				sb.Append(cur.GetString2(i))
			End If
			sb.Append("</td>")
		Next
		sb.Append("</tr>").Append(CRLF)
		
	Next
	cur.Close
	sb.Append("</table></body></html>")
	Return sb.ToString
End Sub

Sub UpdateSelectedItem
Private Query As String
Private Curs As Cursor
	
Query = "SELECT DISTINCT Account,Names, Class,Stream,Amount FROM Balances WHERE ID = " & Starter.IDList.Get(Starter.CurrentIndex)
	Curs = Starter.SQL1.ExecQuery(Query)
	For i = 0 To Curs.RowCount - 1
	Curs.Position = i

If Curs.RowCount > 0 Then
'lblSelectedItem.Text = Curs.GetString("Names") & " " & Curs.GetString("Class")& " " & Curs.GetString("Amount")
Account.Text = Curs.GetString("Account")
Classr.Text= Curs.GetString("Class")
			kname=Curs.GetString("Names")
			Dim jb As HttpJob
			jb.Initialize("", Me)
			jb.Download("http://kccug.com/Generic_Handler_JSON/HandlerVBGTyears.ashx?customerid=" & Account.Text)
			'jb.GetRequest.Timeout = 10000 ' 10 seconds
			Wait For (jb) JobDone(jb As HttpJob)
			If jb.Success Then ' if job is success (http status code 200)
				Dim RetVal As String
				RetVal = jb.GetString
		
				Dim jp As JSONParser
				jp.Initialize(jb.GetString)
				'Log(jp) ' will pr
				Dim quotes As List = jp.NextArray
				For Each quot As Map In quotes
					Log("Years: " & quot.Get("yr"))
		
					Starter.SQL1.ExecNonQuery2("INSERT INTO Years VALUES(?, ?)", Array As Object(quot.Get("yr"), "1"))
		
				Next
			End If
			jb.Release
		
		End If
	Next
InitSpinners
End Sub

Sub InitSpinners
	Private i As Int
	Private Query1 As String
	Private Curs As Cursor
	'query = "CREATE TABLE SMSlist (Account Text, Names Text,Phone text,Sex, ID INTEGER )"
	'We execute a query for each column and fill the Spinner
	'We use SELECT DISTINCT to have each existing first name in the database only once
	Query1 = "SELECT DISTINCT Years FROM Years ORDER BY Years ASC"
	Curs = Starter.SQL1.ExecQuery(Query1)
	'we add 'no filter' as no selection
	spnFirstName.Add("Select from the List...")
	'we fill the Spinner with the data from the database
	For i = 0 To Curs.RowCount - 1
		Curs.Position = i
		'spnFirstName.Add(Curs.GetString("Account"))
		spnFirstName.Add(Curs.GetString("Years"))
		'Dim kk As String = Curs.GetString("Names")
		'Log(kk)
	Next
	'Curs.Close
	
End Sub

Sub Button1_Click
	If IsConnectedToInternet= True Then
	Dim SQLQry As String = "DELETE FROM Alevelreport"
	Starter.SQL1.ExecNonQuery(SQLQry)
	If Account.Text="" Then
		MsgboxAsync("Select the Student Name from the List","SMIS")
		Return
		Else
			If Latestdata.Checked=True Then
		If Classr.Text.Contains("S1")=True Or Classr.Text.Contains("S2")=True  Or Classr.Text.Contains("S3")=True Or Classr.Text.Contains("S4")=True Then
			StartActivity(Academics)
			Else
			If Classr.Text.Contains("P1")=True Or Classr.Text.Contains("P2")=True  Or Classr.Text.Contains("P3")=True Or Classr.Text.Contains("P4")=True Or Classr.Text.Contains("P5")=True Or Classr.Text.Contains("P6")=True Or Classr.Text.Contains("P7")=True Then
				StartActivity(Academics)

				Else
					If Classr.Text.Contains("S5")=True Or Classr.Text.Contains("S6")=True   Then
					Dim jt As HttpJob
					jt.Initialize("", Me)
						jt.Download("http://kccug.com/Generic_Handler_JSON/HandlerVBAlevelreport.ashx?customerid=" & Account.Text)
					jt.GetRequest.Timeout = 10000 ' 10 seconds
					Wait For (jt) JobDone(jt As HttpJob)
					If jt.Success Then ' if job is success (http status code 200)
						Dim RetVal As String
						RetVal = jt.GetString
						Log(RetVal)
						
						If jt.GetString = "[]" Then
							'MsgboxAsync("No Records to Upload Yet for: " & CustID ,"SMIS")
								Return
							Else
								
								Dim parser As JSONParser
								parser.Initialize(jt.GetString)
								Dim root As List = parser.NextArray
								For Each colroot As Map In root
									Dim FieldName As String
									Dim FieldValue As String

									For I = 0 To colroot.Size - 1
										'Log(colroot.GetKeyAt(I) & " = " & colroot.GetValueAt(I))
									FieldName = colroot.GetKeyAt(I)
										'Log(FieldName)
										If FieldName.Trim.ToUpperCase.EndsWith("POINTS") Then
									FieldValue = colroot.GetValueAt(I)
  
									Select Case FieldValue.Trim.ToUpperCase
												Case "A", "B", "C", "D", "E", "O","F"
													
														If FieldValue.Length <> 0 And FieldValue.Length <> 0 Then
											Log(FieldName.Trim & " = " & FieldValue.Trim)
														Starter.SQL1.ExecNonQuery2("INSERT INTO Alevelreport VALUES(?, ?, ?,?,?)", Array As Object(Account.Text,FieldValue.Trim, kname, FieldName.Trim ,"1"))
          									End If
												Case "0", "1", "2", "3", "4", "5", "6","7", "8", "9", "10", "11", "12","13", "14", "15", "16", "17", "18", "19", "20"
													Log("  (Numeric score for " & FieldName.Trim & FieldValue.Trim & ")")
													Starter.SQL1.ExecNonQuery2("INSERT INTO Alevelreport VALUES(?, ?, ?,?,?)", Array As Object(Account.Text,FieldValue.Trim, kname, FieldName.Trim ,"1"))
										Case "F"
													'query = "CREATE TABLE Alevelreport (Account Text, Points Text,Name text,Subject text, ID INTEGER )"
											Log("  (No good at " & FieldName.Trim & ")")
          
									End Select
								
									End If
									
								Next
																	
												jt.Release
						StartActivity(DisplayAlevel)
			Return
								
	
				Next	
			
					
				End If
				End If
			End If
			End If
	End If
	End If
	End If
	Else
		MsgboxAsync("Error Connecting to the Server Please Check Your Internet Connection","Server Error")
		
		End If
		
End Sub

Sub Button2_Click
	StartActivity(Sendmysms)
End Sub