﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim spnFirstName As Spinner
	Dim  DOB As MaskedEditText
	Dim Names As EditText
	Dim Yeard As EditText
	Dim fname As EditText
	Dim fmobile As EditText
	Dim femail As EditText
	Dim Memail As EditText
	Dim mname As EditText
	Dim mmobile As EditText
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("applystudent")
	Activity.Title="New Student Application"
	Dim lt As Long
	DateTime.DateFormat = "dd/MM/yyyy" ' "1961-08-29"
	Dim datestring As String = DateTime.Date(JsonDateToTick( DOB.Text))
	lt = DateTime.DateParse(datestring)
	DateTime.DateFormat = "dd/MM/yyyy"
	Log(lt)
	InitSpinners

End Sub
Sub IsConnectedToInternet As Boolean
	Dim r As Reflector
 
	r.Target = r.GetContext
	r.Target = r.RunMethod2("getSystemService", "connectivity", "java.lang.String")
	r.Target = r.RunMethod("getActiveNetworkInfo")
 
	If r.Target <> Null Then
		Return r.RunMethod("isConnectedOrConnecting")
	End If
 
	Return False
End Sub
Sub JsonDateToTick(s As String) As Long
	Dim m As Matcher = Regex.Matcher("\d+", s)
	If m.Find Then
		Return m.Match
	End If
	Log("Invalid date: " & s)
	Return 0
End Sub



Sub DOB_FocusChanged(HasFocus As Boolean)
	If HasFocus Then
		Dim Test As String
            
		Test = DOB.Text
            
		Test = Test.Replace("/", "")
            
		If IsNumber(Test) Then
			'MaskedEditText2.RequestFocus
		Else

			DOB.ShowError("Invalid date")
			Return

		End If
		
	End If
End Sub

Sub InitSpinners
	Private i As Int
	Private Query1 As String
	Private Curs As Cursor
		
	Query1 = "SELECT DISTINCT Class FROM Classes ORDER BY Class ASC"
	Curs = Starter.SQL1.ExecQuery(Query1)
	'we add 'no filter' as no selection
	spnFirstName.Add("no filter")
	'we fill the Spinner with the data from the database
	For i = 0 To Curs.RowCount - 1
		Curs.Position = i
		spnFirstName.Add(Curs.GetString("Class"))
	Next
End Sub
Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub Button1_Click
	
	If IsNotValidEmail(Memail.Text,"Email Address") = True Then
		Memail.RequestFocus
		 Return
	End If
	If IsNotValidEmail(femail.Text,"Email Address") = True Then
		femail.RequestFocus
		 Return
	End If
	
	If Names.Text="" Then
		MsgboxAsync("You Must Indicate the Student Name  ", "SMIS")
		Names.RequestFocus
	Return
	End If
	
	If spnFirstName.SelectedItem="no filter" Then
		MsgboxAsync("You Must Indicate the Class  ", "SMIS")
		spnFirstName.RequestFocus
		Return
	End If
	
	If Yeard.Text="" Then
		MsgboxAsync("You Must Indicate the Year  ", "SMIS")
		Yeard.RequestFocus
		Return
	End If
	
	If DOB.Text="__/__/____" Then
		MsgboxAsync("You Must Indicate the Date of Birth  ", "SMIS")
		'DOB.RequestFocus
		Return
	End If
	
	If IsConnectedToInternet= True Then
	Dim j As HttpJob
	j.Initialize("", Me)
	j.Download($"http://kccug.com/Generic_Handler_JSON/RecieveApplicant.ashx?n=${Names.Text}&c=${spnFirstName.SelectedItem}&y=${Yeard.Text}&fn=${fname.Text}&fm=${fmobile.Text}&fe=${femail.Text}&mn=${mname.Text}&mm=${mmobile.Text}&mem=${Memail.Text}&dob=${DOB.Text}"$ )
	j.Release
	
MsgboxAsync("You have Successfully Applied Please You will be informed of the interview Date Via Our App or We Shall Call You Thank for Your Support","SMIS")
Else
	MsgboxAsync("Error Connecting to the Server Please Check Your Internet Connection","Server Error")
		Return
	End If
End Sub


Sub IsNotValidEmail(valueToCheck As String, title As String) As Boolean
	valueToCheck = valueToCheck.Trim
	If IsEmail(valueToCheck)= False Then
	MsgboxAsync("Invalid Email address ", "SMIS")
		Return True
	Else
		Return False
	End If
End Sub
Sub IsEmail(EmailAddress As String) As Boolean
	If EmailAddress.Length = 0 Then Return True
	Dim MatchEmail As Matcher = Regex.Matcher("^(?i)[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])$", EmailAddress)
	If MatchEmail.Find = True Then
		Return True
	Else
		Return False
	End If
End Sub
